<template>
	<el-dialog :title="'模板配置（' + dialogTitle + '）'" v-model="dialogVisible" draggable width="900px">
		<el-form :model="state.queryParams" ref="ruleDialogFormRef" inline @submit.native.prevent>
			<el-form-item label="关键字查询" prop="Keyword">
				<el-input v-model="state.queryParams.Keyword" placeholder="模板名称/编码" clearable @keyup.enter="handleQuery" />
			</el-form-item>
			<el-form-item>
				<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
				<el-button @click="resetQuery(ruleDialogFormRef)" class="default-button"> <SvgIcon name="ele-Refresh" class="mr5" />重置 </el-button>
			</el-form-item>
		</el-form>
		<vxe-table
			border
			:loading="state.loading"
			:data="state.tableData"
			:sort-config="{ remote: true }"
			:column-config="{ resizable: true }"
			:row-config="{ isHover: true, height: 30, keyField: 'id' }"
			ref="tableRef"
			max-height="500px"
			show-overflow
			:scrollY="{ enabled: true, gt: 100 }"
			@radio-change="radioChangeEvent"
			:radio-config="{ labelField: 'name', highlight: true }"
		>
			>
			<vxe-column type="radio" fixed="left" title="请选择"></vxe-column>
			<vxe-column field="version" title="模板版本号"></vxe-column>
			<vxe-column field="code" title="模板编码"></vxe-column>
			<vxe-column field="creationTime" title="创建时间" width="160">
				<template #default="{ row }">
					<span>{{ formatDate(row.creationTime, 'YYYY-mm-dd HH:MM:SS') }}</span>
				</template>
			</vxe-column>
		</vxe-table>
		<pagination
			@pagination="queryList"
			:total="state.total"
			v-model:current-page="state.queryParams.PageIndex"
			v-model:page-size="state.queryParams.PageSize"
			:disabled="state.loading"
		/>
		<template #footer>
			<span class="dialog-footer">
				<el-button @click="dialogVisible = false" class="default-button">取 消</el-button>
				<el-button type="primary" @click="onSubmit" :disabled="!state.tableRadio">保 存</el-button>
			</span>
		</template>
	</el-dialog>
</template>

<script lang="tsx" setup name="workflowConfig">
import { defineAsyncComponent, reactive, ref } from 'vue';
import { ElMessage, FormInstance } from 'element-plus';
import { wfmodulesMatch, workflowList } from '@/api/system/workflow';
import { formatDate } from '@/utils/formatTime';

const pagination = defineAsyncComponent(() => import('@/components/ProTable/components/Pagination.vue')); // 分页

// 定义子组件向父组件传值/事件
const emit = defineEmits(['updateList', 'openDialog', 'closeDialog']);

const proTableRef = ref<RefType>(); // 表格ref
// 表格配置项
const columns = ref<any[]>([
	{ type: 'radio', fixed: 'left', width: 80, label: '请选择' },
	{ prop: 'name', label: '模板名称', width: 300 },
	{ prop: 'version', label: '模板版本号' },
	{ prop: 'code', label: '模板编码' },
	{
		prop: 'creationTime',
		label: '创建时间',
		width: 170,
		render: (scope) => {
			return <span>{formatDate(scope.row.creationTime, 'YYYY-mm-dd HH:MM:SS')}</span>;
		},
	},
]);
// 定义变量内容
const state = reactive({
	tableData: [], // 表格数据
	total: 0, // 总条数
	loading: false, // 加载
	queryParams: {
		PageIndex: 1, // 当前页
		PageSize: 10, // 每页条数
		Keyword: null, // 关键字
		Status: '1', // 状态
	},
	tableRadio: '', // 选择的模板
	rowCode: '', // 行数据code
});
const ruleDialogFormRef = ref<FormInstance>(); // 表单
const dialogVisible = ref(false); // 弹窗
const dialogTitle = ref(''); // 弹窗标题

// 打开弹窗
const openDialog = async (row: any) => {
	dialogVisible.value = true;
	try {
		queryList();
		state.rowCode = row.code;
		if (row.definitionId) state.tableRadio = row.definitionId;
		else state.tableRadio = '';
		dialogTitle.value = row.name;
	} catch (error) {
		console.log(error);
		state.loading = false;
	}
};
/** 搜索按钮操作 */
const handleQuery = () => {
	state.queryParams.PageIndex = 1;
	queryList();
};
const tableRef = ref<RefType>();
const queryList = () => {
	state.loading = true;
	workflowList(state.queryParams)
		.then((res: any) => {
			state.tableData = res.result?.items ?? [];
			state.total = res.result?.total ?? 0;
			state.loading = false;
			const row = state.tableData.find((item) => item.id === state.tableRadio);
			tableRef.value.setRadioRow(row);
		})
		.catch(() => {
			state.loading = false;
		});
};
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	queryList();
};

// 关闭弹窗
const closeDialog = () => {
	dialogVisible.value = false;
};
const selectRow = ref<any>(null);
const radioChangeEvent = ({ row }) => {
	selectRow.value = row;
};
// 选择模板
const onSubmit = () => {
	wfmodulesMatch({ code: state.rowCode, definitionId: selectRow.value.id })
		.then(() => {
			ElMessage.success('操作成功');
			emit('updateList');
			dialogVisible.value = false;
		})
		.catch(() => {});
};
//暴漏变量和方法
defineExpose({ closeDialog, openDialog });
</script>
